import java.io.*;
import java.nio.*;
import java.nio.charset.*;

public class TimeCharset {

	public static void main(String args[]) throws Exception {
		String data = "abcdef1234";

		int limit = 10000000;
		System.out.println("Doing " + limit + " iterations of each.");

		long t1, t2;

		t1 = System.currentTimeMillis();
		for (int i=0; i<limit; i++) {
			data.getBytes("UTF-8");
		}
		t2 = System.currentTimeMillis();
		System.out.println((t2-t1) + " getBytes(String)");

		Charset utf8 = Charset.forName("UTF-8");
		t1 = System.currentTimeMillis();
		for (int i=0; i<limit; i++) {
			data.getBytes(utf8);
		}
		t2 = System.currentTimeMillis();
		System.out.println((t2-t1) + " getBytes(Charset)");


		t1 = System.currentTimeMillis();
		for (int i=0; i<limit; i++) {
			ByteBuffer buf = utf8.encode(CharBuffer.wrap(data));
			byte b[] = new byte[buf.limit()];
			buf.get(b, 0, buf.limit());
		}
		t2 = System.currentTimeMillis();
		System.out.println((t2-t1) + " via ByteBuffer");
	}
}

